#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <pthread.h>
#include "des.h"
#include "model.h"

#define THREADS      6

char cipher[] = {0x86, 0x18, 0xB5, 0x3C, 0x32, 0xBF, 0x8E, 0x0B};

void* cracker_thread(void* data);


int main()
{

	// initialize key space
	init_key_space(KEY_BLOCK_SIZE);
	
 	pthread_t* threads = (pthread_t*)malloc(THREADS * sizeof(pthread_t));
 	
	int i;
	for(i = 0; i < THREADS; i++)
	{
		int ret = pthread_create(&threads[i], NULL, cracker_thread, NULL);
		printf("* thread created with ret %d\n", ret);
		pthread_detach(threads[i]);
		usleep(1000);
	}
	
	system("PAUSE");
    return 0;
}

void* cracker_thread(void* data)
{
	// request initial key blocks
    KEY_BLOCK** p_head = NULL;
	unsigned long n_actual = 0, total_blocks = 0, total_keys = 0;
	get_key_blocks(BLOCKS_PER_REQ, &p_head, &n_actual);
	total_blocks += n_actual;
	
	do
	{
	    unsigned long i, j, k;
	    for(i = 0; i < n_actual; i++)
	    {
			for(j = 0; j < p_head[i]->size; j++)
			{
				total_keys++;
				// should be data length here, although same
				char* decrypted = (char*)malloc((KEY_LENGTH + 1) * sizeof(char));
				Decrypt((p_head[i]->p_keys + j * KEY_LENGTH), cipher, decrypted, KEY_LENGTH);
				
				// is there a better way to do this?
				if(memcmp("server", decrypted, 6) == 0)
	    		{
	    			char output[20];
					memset(output, ' ', 20);
					output[19] = 0;
	    			memcpy(output, p_head[i]->p_keys + j * KEY_LENGTH, KEY_LENGTH);
	    			memcpy(output + KEY_LENGTH + 1, decrypted, KEY_LENGTH);
            		printf("%s\n", output);
	    		}
            	free(decrypted);
            }
	    }
		
		// request new key blocks
    	destroy_key_blocks(p_head, n_actual);
    	free(p_head);
    	get_key_blocks(BLOCKS_PER_REQ, &p_head, &n_actual);
    	total_blocks += n_actual;
	}while(n_actual != 0);
	printf("\n# thread exits with total %u blocks %u keys\n", total_blocks, total_keys);
}
