#include <stdlib.h>
#include <string.h>
#include <pthread.h>

#ifdef __linux__
	#include <sys/time.h>
#else
	#include <time.h>
#endif

#define TOTAL_KEYS        4294967296
#define KEY_BLOCK_SIZE    65536
#define KEY_BUF_SIZE      65536
#define KEY_LENGTH        8
#define BLOCKS_PER_REQ    64

typedef struct
{
	char* p_keys;
	unsigned long start;
	unsigned long size;
} KEY_BLOCK;

typedef struct
{
	KEY_BLOCK** p_blocks;
	unsigned long size;
	unsigned long current;
} KEY_POOL;

void init_key_space(unsigned long block_size);
void get_key_blocks(unsigned long n_req, KEY_BLOCK*** p_head, unsigned long* n_acutal);
void destroy_key_blocks(KEY_BLOCK** p_head, unsigned long size);

